#define UNICODE
#define _UNICODE
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <shellapi.h>
#include <tlhelp32.h>
#include <tchar.h>
#include "resource.h"

#pragma comment(linker, "/subsystem:windows,5.0 /defaultlib:kernel32.lib /defaultlib:user32.lib")

#define GUID_ALLGDIPLUSPLUS		_T("{FD21E0BB-24FB-41d4-8DB0-081D2E4DF0EC}")

#ifndef WM_TRAYICONMESSAGE
#define WM_TRAYICONMESSAGE WM_USER + 1
#endif  WM_TRAYICONMESSAGE

#define IDM_EXIT  101
#define IDM_ENABLED  102
#define IDM_DISABLED 102

/***/
#define IDM_EDITINI 103
#define IDM_OPENDIR 104

HHOOK     g_hHook = NULL;
HINSTANCE g_hInstance = NULL;
HINSTANCE g_hinstDLL = NULL;
TCHAR* g_lpszAppName = _T("gdi++ManagerWnd");

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
void WINAPI UnloadALL();
int InitializeHook();

/***/
void add_title(wchar_t *path, wchar_t *title);
void del_title(wchar_t *path);
void OnTrayMenu(HWND hwnd, bool isINI);

/***/
int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE/* hPrevInstance*/, LPTSTR lpCmdLine, int /*nCmdShow*/)
{
/***/
	//if(GetVersion() & 0x80000000) {
	//	MessageBox(NULL, L"Win9xł͓삵܂.", NULL, MB_ICONSTOP | MB_TOPMOST);
	//	return NULL;
	//}

	MSG  msg = {0,0,0,0,0,0};
	HWND hWnd;

	HANDLE hMutex = CreateMutex(FALSE, 0, g_lpszAppName);
	if(GetLastError() == ERROR_ALREADY_EXISTS) {
		CloseHandle(hMutex);
		return FALSE;
	}

	WNDCLASSEX wc;
	ZeroMemory(&wc, sizeof(WNDCLASSEX));
	wc.cbSize        = sizeof(WNDCLASSEX);
	wc.style         = CS_DBLCLKS;
	wc.lpfnWndProc   = (WNDPROC)WndProc;
	wc.hInstance     = hInstance;
	wc.lpszClassName = g_lpszAppName;
	if(!RegisterClassEx(&wc)) return 0;
	g_hInstance = hInstance;

	hWnd = CreateWindow(g_lpszAppName, g_lpszAppName, WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, CW_USEDEFAULT,
		CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);

	if(!hWnd) return 0;
	if (lstrcmpi(lpCmdLine, _T("-on")) == 0) { InitializeHook(); }

	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	CloseHandle(hMutex);
	/***/
	return (int)msg.wParam;
}

// ʒm̈ɃACRo^
int SetTaskTrayIcon(HWND hwnd, PNOTIFYICONDATA lpni) {
	//ZeroMemory(&lpni, sizeof(NOTIFYICONDATA));
	lpni->cbSize           = sizeof(NOTIFYICONDATA);
	lpni->hIcon            = (HICON)LoadImage(g_hInstance, MAKEINTRESOURCE(IDI_APPICON), IMAGE_ICON, 16, 16, 0);
	lpni->hWnd             = hwnd;
	lpni->uCallbackMessage = WM_TRAYICONMESSAGE;
	lpni->uFlags           = NIF_ICON | NIF_MESSAGE | NIF_TIP;
	lpni->uID              = 1;
	lstrcpy(lpni->szTip, _T("gdi++"));
	// o^݂
	while (!Shell_NotifyIcon(NIM_ADD, lpni)) {
		if (GetLastError() != ERROR_TIMEOUT) { return FALSE; }
		Sleep(1000);
	}
	return TRUE;
}

int InitializeHook(){
	g_hinstDLL = LoadLibrary(_T("GDI++.DLL"));
	HOOKPROC p = (HOOKPROC)GetProcAddress(g_hinstDLL, "GetMsgProc");
	if(!g_hinstDLL || !p)
		return MessageBox(NULL, _T("GDI++.DLL[hł܂"), NULL, MB_ICONHAND);
	g_hHook = SetWindowsHookEx(WH_GETMESSAGE, p, g_hinstDLL, 0);
	if(!g_hHook)
		return MessageBox(NULL, _T("tbNɎs܂"), NULL, MB_ICONHAND);
	PostMessage(HWND_BROADCAST, WM_NULL, 0, 0);
	RedrawWindow(GetDesktopWindow(), NULL, NULL, RDW_INVALIDATE | RDW_ERASE | RDW_ALLCHILDREN);
	return TRUE;
}

int TerminateHook(){
	UnloadALL();
	if (g_hHook) UnhookWindowsHookEx(g_hHook);
	g_hHook = NULL;
	g_hinstDLL = NULL;
	PostMessage(HWND_BROADCAST, WM_NULL, 0, 0);
	RedrawWindow(GetDesktopWindow(), NULL, NULL, RDW_INVALIDATE | RDW_ERASE | RDW_ALLCHILDREN);
	return TRUE;
}

BOOL _RemoteFreeLibrary(DWORD dwProcessId, HMODULE hModule, BOOL bForceUnload = FALSE)
{
	HANDLE hProcess = OpenProcess(PROCESS_CREATE_THREAD | PROCESS_QUERY_INFORMATION |
									PROCESS_VM_OPERATION | PROCESS_VM_WRITE | PROCESS_VM_READ,
									TRUE, dwProcessId);
	if (!hProcess)
		return FALSE;

	DWORD ret = 0;
	DWORD dwThreadId;
	HANDLE hThread;

	for (;;) {

		hThread = CreateRemoteThread(hProcess, NULL, 0,
									(LPTHREAD_START_ROUTINE)FreeLibrary,
									hModule, 0, &dwThreadId);

		if(!hThread) {
			ret = FALSE;
			break;
		}

		WaitForSingleObject(hThread, INFINITE);
		GetExitCodeThread(hThread, &ret);
		CloseHandle(hThread);

		if(!bForceUnload)
			break;
		if(!ret) {
			ret = TRUE;
			break;
		}
	}

	CloseHandle(hProcess);
	return ret;
}

void WINAPI UnloadALL()
{
	HANDLE hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
	if(hSnapshot == INVALID_HANDLE_VALUE)
		return;

	//DWORD dwMyProcessId = GetCurrentProcessId();
	PROCESSENTRY32 pe = { sizeof(PROCESSENTRY32) };
	BOOL ret = Process32First(hSnapshot, &pe);

	while(ret && GetLastError() != ERROR_NO_MORE_FILES) {
	//	if(pe.th32ProcessID != dwMyProcessId) {
			HANDLE hSnapModule = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, pe.th32ProcessID);
			if(hSnapModule != INVALID_HANDLE_VALUE) {
				MODULEENTRY32 me = { sizeof(MODULEENTRY32) };
				ret = Module32First(hSnapModule, &me);
				while(ret && GetLastError() != ERROR_NO_MORE_FILES) {
//					MessageBox(NULL, me.szExePath, me.szModule, MB_OK);
					if(lstrcmpi(me.szModule, _T("gdi++.dll")) == 0) {
						_RemoteFreeLibrary(pe.th32ProcessID, me.hModule, TRUE);
					}
					SetLastError(0);
					ret = Module32Next(hSnapModule, &me);
				}
				CloseHandle(hSnapModule);
			}
		//}
		SetLastError(0);
		ret = Process32Next(hSnapshot, &pe);
	}
	CloseHandle(hSnapshot);
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	static NOTIFYICONDATA nid;
	static BOOL bIconVisible = FALSE;

	static UINT	s_taskbarRestart = RegisterWindowMessage(_T("TaskbarCreated"));

	switch(uMsg)
	{
		case WM_COMMAND:
			switch(LOWORD(wParam)) {
				case IDM_EDITINI: //edit ini
					OnTrayMenu(hWnd, true);
					break;
				case IDM_OPENDIR: //open dir
					OnTrayMenu(hWnd, false);
					break;
				case IDM_ENABLED:
					if (g_hHook == NULL) {
						InitializeHook();
					} else {
						TerminateHook();
					}
					break;
				case IDM_EXIT: //I
					SendMessage(hWnd, WM_CLOSE, 0, 0);
					break;
			}
		case WM_CREATE:
			s_taskbarRestart = RegisterWindowMessage(_T("TaskbarCreated"));

			if (bIconVisible) return 0;
			/*
			ZeroMemory(&nid, sizeof(NOTIFYICONDATA));
			nid.cbSize = sizeof(NOTIFYICONDATA);
			nid.hWnd = hWnd;
			nid.uID = 1;
			nid.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
			nid.uCallbackMessage = WM_TRAYICONMESSAGE;
			nid.hIcon = (HICON)LoadImage(g_hInstance, MAKEINTRESOURCE(IDI_APPICON), IMAGE_ICON, 16, 16, 0);
			lstrcpy(nid.szTip, _T("gdi++"));
			if(!Shell_NotifyIcon(NIM_ADD, &nid))
				return -1;
				*/
			if (FALSE == (bIconVisible = SetTaskTrayIcon(hWnd, &nid))) return -1;
			break;
		case WM_TRAYICONMESSAGE:
			if(wParam == 1) {
				if(lParam == WM_RBUTTONUP) {
					POINT pt;
					MSG msg;
					GetCursorPos(&pt);
					HMENU hMenu = CreatePopupMenu();
					if (g_hinstDLL) {
						AppendMenu(hMenu,MF_BYCOMMAND | MF_STRING, IDM_EDITINI, _T("INIt@CJ(&I)"));
						AppendMenu(hMenu,MF_BYCOMMAND | MF_STRING, IDM_OPENDIR, _T("DLLfBNgJ(&D)"));
					}
					AppendMenu(hMenu,MF_BYCOMMAND | MF_STRING, IDM_ENABLED, _T("L(&E)"));
					AppendMenu(hMenu, MF_BYCOMMAND | MF_STRING, IDM_EXIT, _T("I(&X)"));
					if (g_hHook != NULL) CheckMenuItem(hMenu, IDM_ENABLED, MF_CHECKED);
					SetForegroundWindow(hWnd);
					TrackPopupMenu(hMenu, TPM_RIGHTBUTTON, pt.x, pt.y, 0, hWnd, NULL);
					if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {
						TranslateMessage(&msg);
						DispatchMessage(&msg);
					}
					DestroyMenu(hMenu);
				} else if (lParam == WM_LBUTTONDBLCLK) {
					if (g_hHook == NULL) {
						InitializeHook();
					} else {
						TerminateHook();
					}
				}
			}
			break;
		case WM_DESTROY:
			TerminateHook();
			Shell_NotifyIcon(NIM_DELETE, &nid);
			PostQuitMessage(0);
			break;
		default:
			if (uMsg == s_taskbarRestart) {
				if (FALSE == (bIconVisible = SetTaskTrayIcon(hWnd, &nid))) {
					MessageBox(NULL,_T("ACRo^łȂߏI܂"), NULL, MB_ICONSTOP | MB_TOPMOST);
					SendMessage(hWnd, WM_CLOSE, 0, 0);
				}
			} else {
				return DefWindowProc(hWnd, uMsg, wParam, lParam);
			}
	}
	return 0;
}



/***/
void OnTrayMenu(HWND hwnd, bool isINI) {
	TCHAR dllPath[MAX_PATH];
	HINSTANCE ret;

	GetModuleFileName(g_hinstDLL, dllPath, sizeof(dllPath));
	del_title(dllPath);
	if (isINI)
		add_title(dllPath, _T("gdi++.ini"));
	ret = ShellExecute(hwnd, NULL, dllPath, NULL, NULL, SW_SHOWNORMAL);

	if (32 >= (int)ret) {
		if (SE_ERR_ASSOCINCOMPLETE == (int)ret) {
			MessageBox(NULL, _T("pXJ܂Bt@Cɑ΂Ċ֘At܂"), NULL, MB_ICONSTOP | MB_TOPMOST);

		} else {
			MessageBox(NULL, _T("pXJ܂Bt@C܂B"), NULL, MB_ICONSTOP | MB_TOPMOST);
		}
	}
}

// tclock2chĂ
// splitpathł
void add_title(wchar_t *path, wchar_t *title)
{
	wchar_t *p;

	p = path;

	if(*p == 0) ;
	else if(*title && *(title + 1) == ':') ;
	else if(*title == '\\')
	{
		if(*p && *(p + 1) == ':') p += 2;
	}
	else
	{
		while(*p)
		{
			if((*p == '\\' || *p == '/') && *(p + 1) == 0)
			{
				break;
			}
			p = CharNext(p);
		}
		*p++ = '\\';
	}
	while(*title) *p++ = *title++;
	*p = 0;
}

void del_title(wchar_t *path)
{
	wchar_t *p, *ep;

	p = ep = path;
	while(*p)
	{
		if(*p == '\\' || *p == '/')
		{
			if(p > path && *(p - 1) == ':') ep = p + 1;
			else ep = p;
		}
		p = CharNext(p);
	}
	*ep = 0;
}


// EOF
